extern "C" char EmptyString[1];

class string
{
protected:
	unsigned int len;
	bool alloc;

public:
	char* buffer;

protected:
	inline void savefree()
	{
		if (alloc)
		{
			freel(buffer);
			alloc = false;
		}
	}

	inline char* savealloc(const size_t Bytes)
	{
		char* tmpBuffer;

		if (Bytes == 1)
		{
			alloc = false;
			return(EmptyString);
		}

		tmpBuffer = (char*) mallocl(Bytes, "String");
		alloc = true;
		
		return(tmpBuffer);
	}

public:

	string(const char* pInit = NULL)
	{
		//printf("Konstruktor\n");
		if (pInit)
		{
			len = strlen(pInit);
			buffer = savealloc(len + 1);
			CopyMemory(buffer, pInit, len + 1);
		}
		else
		{
			buffer = EmptyString;
			len = 0;
			alloc = false;
		}
	}

	~string()
	{
		//printf("Destruktor\n");
		savefree();
	}

	string(const string& strInit)
	{
		//printf("Kopier-Konstruktor\n");
		if (strInit.alloc)
		{
			len = strInit.len;
			buffer = savealloc(len + 1);
			CopyMemory(buffer, strInit.buffer, len + 1);
		}
		else
		{
			buffer = EmptyString;
			len = 0;
			alloc = false;
		}
	}

	char* operator =(const char* pStr)
	{
		//printf("= char*\n");
		savefree();
		len = strlen(pStr);
		buffer = savealloc(len + 1);
		CopyMemory(buffer, pStr, len + 1);

		return(buffer);
	}

	char* operator =(const string& strStr)
	{
		//printf("= string\n");
		savefree();
		if (len = strStr.len)
		{
			buffer = savealloc(len + 1);
			CopyMemory(buffer, strStr.buffer, len + 1);
		}
		else
		{
			savefree();
			buffer = EmptyString;
		}
		return(buffer);
	}

	char* operator +=(const string& strStr)
	{
		bool allocOld, allocNew;

		allocOld = alloc;
		//printf("+= string\n");
		int tmpLen = len + strStr.len;
		char* tmpBuffer = savealloc(tmpLen + 1);
		allocNew = alloc;
		alloc = allocOld;
		CopyMemory(tmpBuffer, buffer, len);
		CopyMemory(tmpBuffer + len, strStr.buffer, strStr.len + 1);
		savefree();
		alloc = allocNew;
		buffer = tmpBuffer;
		len = tmpLen;
		return(buffer);
	}

	char* operator +=(const char* pStr)
	{
		bool allocOld, allocNew;

		allocOld = alloc;
		//printf("+= char*\n");
		int tmpLen = len + strlen(pStr);
		char* tmpBuffer = savealloc(tmpLen + 1);
		allocNew = alloc;
		alloc = allocOld;
		CopyMemory(tmpBuffer, buffer, len);
		CopyMemory(tmpBuffer + len, pStr, strlen(pStr) + 1);
		savefree();
		alloc = allocNew;
		buffer = tmpBuffer;
		len = tmpLen;
		return(buffer);
	}

	int operator ==(const char* pStr)
	{
		//printf("== char*\n");
		return(strlen(pStr) == len && strcmp(buffer, pStr) == 0);
	}

	int operator ==(const string& strStr)
	{
		//printf("== string\n");
		return(len == strStr.len && strncmp(buffer, strStr.buffer, len) == 0);
	}

	template <class T>int operator !=(T pStr)
	{
		//printf("!=\n");
		return(!(*this == pStr));
	}

	friend size_t strlen(const string& strStr);
	friend inline char* strcat(char* pStr, const string& strStrCat);
	friend inline char* strcpy(char* pStr, const string& strStrCpy);
	friend inline void ucase(string& strStr);
};

extern inline size_t strlen(const string& strStr);

template <class T> extern inline char* strcat(string& strStr, const T& pStrCat);
extern inline char* strcat(char* pStr, const string& strStrCat);
template <class T> extern inline char* strcpy(string& strStr, const T& pStrCpy);
extern inline char* strcpy(char* pStr, const string& strStrCpy);

#ifndef gccruntime
#ifndef vsnetruntime
#ifndef vectorcruntime

template <class T> extern inline int strcmp(const string& strStr, const T& pStrCmp);
extern inline int strcmp(const char* pStr, string& strStrCmp);

#endif
#endif
#endif

extern inline char* strstr(const string& strStr, const string& strStrstr);
extern inline char* strstr(const string& strStr, const char* pStrstr);
extern inline char* strstr(const char* pStr, const string& strStrstr);

extern inline void ucase(string& strStr);
extern inline void ucase(char* strStr);
