#include "defines.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

extern int manual, manual2;
extern "C" int DebugOutput;
extern int RuntimeOutput;
extern int ChooseClass;
extern int calctype, adverror, loop;

extern int randstackinit;
extern int randstacktmp;

int randstack;
int arandstack;
int mrandstack;
int brandstack;
int brrandstack;

extern bool UseIsaac;

extern void quitprog(bool save = true);
extern unsigned int intpart(unsigned int val, unsigned int part);

extern unsigned int isaacrand(unsigned int Min, unsigned int Max, bool Init = false, unsigned long int* seed = NULL);

int radr;
int useagaincount = 0;

extern "C" int useagain[BufferLen];
extern "C" int useagainaddr[BufferLen];

char tempscanstr[256];
char* tempscanstra;
int usei;
int savethis = 0;

extern int reproduce;
extern int readreproducea;

extern unsigned int* retemp;
extern unsigned int* prepos;

extern FILE* reRead;
char rebuf[16];

int skipped, skipped2;
int nonefound;

int arandchild = 0;

int manualinrand;

unsigned int random(int min, int max, char* Text, int OverrideManual = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne norandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov randstack, eax

norandstackinit:

		mov ebx, esp
		add ebx, randstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif

	if (randstackinit)
	{
		return(0);
	}

	if (min == max)
	{
		return(min);
	}

	unsigned int temp = 0, temp2, temp3, i, j;
	int stemp = 0;

	if (OverrideManual == -1 || Text[0] == 0)
	{
		manualinrand = 0;
		OverrideManual = 0;
	}
	else
	{
		manualinrand = manual;
	}

	if (UseIsaac)
	{
		return(isaacrand(min, max));
	}

	skipped = 0;
	nonefound = 0;

	if (readreproducea)
	{
		adverror = 1;
		return(retemp[(*prepos)++]);
	}

	if (manualinrand || DebugOutput || OverrideManual)
	{
		printf("\n-------------------------------------------------------------------------------\nManuel Random (%s):\nBitte Zahl zwischen %d und %d eingeben!   ", Text, min, max);
		if (RuntimeOutput || DebugOutput == 0)
		{
			printf("\n(Called from %d)   :", radr);
		}
	}

rescan:
	skipped2 = 0;
	for (usei = 0;usei < useagaincount;usei++)
	{
		if (useagainaddr[usei] == radr)
		{
			if (skipped2 == skipped)
			{
				stemp = useagain[usei];
				goto scandone;
			}
			else
			{
				skipped2++;
			}
		}
	}
	nonefound = 1;
	
	if (manualinrand || OverrideManual)
	{
		do
		{
			if (nonefound == 0)
			{
				skipped++;
				goto rescan;
			}
			savethis = 0;
			scanf("%s", tempscanstr);
			if (tempscanstr[0] == 42)
			{
#ifdef noasm
				printf("* NOT SUPPORTED IN THIS RUNTIME\n");
#else
				savethis = 1;
#endif
				tempscanstra = tempscanstr + 1;
			}
			else
			{
				tempscanstra = tempscanstr;
			}
				
			stemp = atoi(tempscanstra);
			
scandone:
			if (stemp < 0)
			{
				if (savethis)
				{
					if (useagaincount == BufferLen)
					{
						printf("Stack Table Overflow, Increase BufferLen and recompile!\n");
						breakpoint("random");
					}
					useagain[useagaincount] = stemp;
					useagainaddr[useagaincount] = radr;
					useagaincount++;
					savethis = 0;
				}
				goto autorandom;
			}
		} while (stemp < min || stemp > max);
		if (savethis)
		{
			if (useagaincount == BufferLen)
			{
				printf("Stack Table Overflow, Increase BufferLen and recompile!\n");
				breakpoint("random");
			}
			useagain[useagaincount] = stemp;
			useagainaddr[useagaincount] = radr;
			useagaincount++;
			savethis = 0;
		}
		if (reproduce == 1 && arandchild == 0)
		{
			retemp[*prepos] = stemp;
			(*prepos)++;
		}
		return(stemp);
	}

autorandom:;
	if (stemp == -1) {manual = 0;}
	if (stemp == -2) {manual = 0;manual2 = 0;ChooseClass = 0;}

	for (i = 0;i < 8;i++)
	{
		temp *= 16;
		temp2 = 0;
		for (j = 1;j <= 4;j++)
		{
			temp3 = intpart(rand(), j);
			temp2 ^= temp3;
		}
		temp += temp2;
	}
	temp = (signed) (temp % (max - min + 1)) + min;
	if (reproduce == 1 && arandchild == 0)
	{
		retemp[*prepos] = temp;
		(*prepos)++;
	}
	return(temp);
}

int auseagaincount = 0;

extern "C" int auseagain[BufferLen];
extern "C" int auseagainaddr[BufferLen];

char atempscanstr[256];
char* atempscanstra;
int ausei;
int asavethis = 0;

int AdvancedRand(int number, const int* firstval, int jump, const char* Text, int TextJump, char* Text2, int OverrideManual = 0, int TextPointer = 0, int ForceAddress = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne noarandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov arandstack, eax

noarandstackinit:

		mov ebx, esp
		add ebx, arandstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif

	if (randstackinit)
	{
		return(0);
	}

	if (ForceAddress)
	{
		radr = ForceAddress;
	}

	if (number == 1)
	{
		return(0);
	}
	
	int addval = 0, tempval = 0, tempval2;
	int* curval;
	int* tempvals;
	int i;

	int realnumber, realnumbercur;

	int maxval = 0;
	int highestval = 0;
	skipped = 0;
	nonefound = 0;

	if (OverrideManual == -1  || (TextPointer == 0 ? Text : (*((char**) Text)))[0] == 0 )
	{
		manualinrand = 0;
		OverrideManual = 0;
	}
	else
	{
		manualinrand = manual;
	}

	if (readreproducea)
	{
		adverror = 1;
		return((signed) retemp[(*prepos)++]);
	}

	tempvals = (int*) mallocl(number * sizeof(int), "AdvancedRand-tempvals");

	if (calctype == 1 || calctype == 2)
	{
		for (i = 0;i < number;i++)
		{
			curval = (int*) (((char*) firstval) + i * jump);
			if (*curval > maxval)
			{
				maxval = *curval;
				highestval = i;
			}
		}

		if (calctype == 2 && OverrideManual == 0 && manual == 0)
		{
			if (reproduce == 1)
			{
				retemp[*prepos] = highestval;
				(*prepos)++;
			}
			freel(tempvals);
			return(highestval);
		}
		else if (maxval > 15000)
		{
			maxval = max(1, maxval / 30000);
		}
		else
		{
			maxval = 0;
		}
	}

	realnumber = 0;
	for (i = 0;i < number;i++)
	{
		curval = (int*) (((char*) firstval) + i * jump);
		tempval2 = *curval;
		if (calctype == 1)
		{
			if (maxval)
			{
				tempval2 /= maxval;
			}
			tempval2 *= tempval2;
		}
		else if (calctype == -1)
		{
			tempval2 = (int) sqrt(tempval2);
		}
		if (*curval >= 0)
		{
			realnumber++;
			realnumbercur = i;
			addval += tempval2;
		}
		else
		{
			printf("Negative Probability...\n");
			quitprog();
			freel(tempvals);
			return(-2);
		}
		tempvals[i] = addval;
	}

	if (realnumber == 1)
	{
		freel(tempvals);
		return(realnumbercur);
	}

	if (addval == 0)
	{
		if (adverror == 0)
		{
			adverror = 1;
		}
		else
		{
			loop = 0;
			printf("No Probability given\n");
			quitprog();
		}
		if (reproduce == 1)
		{
			retemp[*prepos] = (unsigned) -1;
			(*prepos)++;
		}
		freel(tempvals);
		if (manualinrand || DebugOutput || OverrideManual)
		{
			printf("Rckgabe -1 da keine wahrscheinlichkeit\n");
		}
		return(-1);
	}
	adverror = 1;

	if (manualinrand || DebugOutput || OverrideManual)
	{
		printf("\n-------------------------------------------------------------------------------\nManuel AdvancedRand\n");
		printf("(%s:)\n", Text2);
		if (RuntimeOutput || DebugOutput == 0)
		{
			printf("(Called from %d)\n", radr);
		}
		for (i = 0;i < number;i++)
		{
			if (*((int*) (((char*) firstval) + i * jump)) > 0)
			{
				if (calctype == 1)
				{
					printf("%d: (%d / %d): %s\n", i, *((int*) (((char*) firstval) + i * jump)) * *((int*) (((char*) firstval) + i * jump)) / maxval, addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
				else if (calctype == -1)
				{
					printf("%d: (%d / %d): %s\n", i, (int) sqrt(*((int*) (((char*) firstval) + i * jump))), addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
				else
				{
					printf("%d: (%d / %d): %s\n", i, *((int*) (((char*) firstval) + i * jump)), addval, (TextPointer == 0 ? Text + i * TextJump : (*((char**) (Text + i * TextJump)))));
				}
			}
		}
	}

arescan:
	skipped2 = 0;
	for (ausei = 0;ausei < auseagaincount;ausei++)
	{
		if (auseagainaddr[ausei] == radr)
		{
			if (skipped2 == skipped)
			{
				tempval = auseagain[ausei];
				goto ascandone;
			}
			else
			{
				skipped2++;
			}
		}
	}
	nonefound = 1;
	
	if (manualinrand || OverrideManual)
	{
		do
		{
			if (nonefound == 0)
			{
				skipped++;
				goto arescan;
			}
			asavethis = 0;
			scanf("%s", atempscanstr);
			if (atempscanstr[0] == 42)
			{
#ifdef noasm
				printf("* NOT SUPPORTED IN THIS RUNTIME\n");
#else
				asavethis = 1;
#endif
				atempscanstra = atempscanstr + 1;
			}
			else
			{
				atempscanstra = atempscanstr;
			}

			tempval = atoi(atempscanstra);
			
ascandone:
			if (tempval < 0)
			{
				if (asavethis)
				{
					if (auseagaincount == BufferLen)
					{
						printf("Stack Table Overflow, Increase BufferLen and recompile!\n");
						breakpoint("AdvancedRand");
					}
					auseagain[auseagaincount] = tempval;
					auseagainaddr[auseagaincount] = radr;
					auseagaincount++;
					asavethis = 0;
				}
				goto autoadvrand;
			}

		} while (tempval < 0 || tempval >= number || *((int*) (((char*) firstval) + tempval * jump)) <= 0);
		freel(tempvals);
		if (asavethis)
		{
			if (auseagaincount == BufferLen)
			{
				printf("Stack Table Overflow, Increase BufferLen and recompile!\n");
				breakpoint("AdvancedRand");
			}
			auseagain[auseagaincount] = tempval;
			auseagainaddr[auseagaincount] = radr;
			auseagaincount++;
			asavethis = 0;
		}
		
		if (reproduce == 1)
		{
			retemp[*prepos] = tempval;
			(*prepos)++;
		}
		return(tempval);
	}

autoadvrand:;
	if (tempval == -1) {manual = 0;}
	if (tempval == -2) {manual = 0;manual2 = 0;ChooseClass = 0;}

	arandchild = 1;
	tempval = random(1, addval, "");
	arandchild = 0;

	for (i = 0;i < number;i++)
	{
		if (tempvals[i] >= tempval)
		{
			freel(tempvals);
			if (DebugOutput) {printf("Selected: %d\n", i);}
			if (reproduce == 1)
			{
				retemp[*prepos] = i;
				(*prepos)++;
			}
			return(i);
		}
	}
	freel(tempvals);
	return(0);
}

int __cdecl multirand(char* text, int ChooseClass, int ForceAddress, ...)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne noarandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov mrandstack, eax

noarandstackinit:

		mov ebx, esp
		add ebx, mrandstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif

	if (randstackinit)
	{
		return(0);
	}

	if (ForceAddress)
	{
		radr = ForceAddress;
	}

	int endarg;
	int argprob;
	char* argtext;
	int i, argcount;
	int* prob;
	char** texts;

	for (i = 0;i < 2;i++)
	{
		if (i)
		{
			prob = (int*) mallocl(argcount * sizeof(int), "multirand-prob");
			texts = (char**) mallocl(argcount * sizeof(int), "multirand-prob");
		}

		argcount = 0;

		va_list valist;
		va_start(valist, ForceAddress);
		endarg = va_arg(valist, int);

		argprob = va_arg(valist, int);
		while (argprob != endarg)
		{
			argtext = va_arg(valist, char*);

			if (i)
			{
				prob[argcount] = argprob;
				texts[argcount] = argtext;
			}
			argcount++;

			argprob = va_arg(valist, int);
		}
		va_end(valist);
	}

	i = AdvancedRand(argcount, prob, sizeof(int), (char*) texts, sizeof(char*), text, ChooseClass, 1, radr);

	freel(prob);
	freel(texts);

	return(i);
}

int boolrand (char* text, int val1, int val2, int ChooseClass = 0, int ForceAddress = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne noarandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov brandstack, eax

noarandstackinit:

		mov ebx, esp
		add ebx, brandstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif
	if (randstackinit)
	{
		return(0);
	}

	if (ForceAddress)
	{
		radr = ForceAddress;
	}

	if (val1 == 0)
	{
		return(1);
	}

	if (val2 == 0)
	{
		return(0);
	}

	return(multirand(text, ChooseClass, radr, 0, val1, "Nein", val2, "Ja", 0));
}

int boolrandborder(char* text, int val1, int val2, int border, int part, int ChooseClass = 0)
{
#ifndef noasm
	__asm
	{
		cmp randstackinit, 1
		jne noarandstackinit

		mov eax, randstacktmp
		sub eax, esp
		mov brrandstack, eax

noarandstackinit:

		mov ebx, esp
		add ebx, brrandstack
		mov eax, ss:[ebx - 4]
		mov radr, eax
	}
#endif
	if (randstackinit)
	{
		return(0);
	}

	if (border >= val2)
	{
		return(1 ^ part);
	}

	if (border <= val1)
	{
		return(part);
	}

	if (part)
	{
		return(boolrand(text, border - val1, val2 - border, ChooseClass, radr));
	}
	else
	{
		return(boolrand(text, val2 - border, border - val1, ChooseClass, radr));
	}
}
